package com.huaching.parking.local.parking_local_general.domain.local.pojo.chargeCalculator;

import com.huaching.parking.local.parking_local_general.util.local.DateUtils;

import java.util.Date;

/**
 * @program: parking_local_general
 * @description: 首时段收费
 * @author: lidongsheng
 * @createData: 2020-05-27 10:39
 * @updateAuthor: lidongsheng
 * @updateData: 2020-05-27 10:39
 * @updateContent:
 * @Version: 1.0.0
 * ************************************************
 * Copyright @ 李东升 2020. All rights reserved
 * ************************************************
 */

public class BaseChargeDetailPOJO<T> {

    //首时段的时间
    private Integer fastTime;
    //首时段类型 0 按分钟 1按小时
    private Integer fastFrameType;
    //首时段金额
    private Integer fastMoney;

    private T data;

    public T getData() {
        return data;
    }

    public void setData(T data) {
        this.data = data;
    }

    public Integer getFastTime() {
        return fastTime;
    }

    public void setFastTime(Integer fastTime) {
        this.fastTime = fastTime;
    }

    public Integer getFastFrameType() {
        return fastFrameType;
    }

    public void setFastFrameType(Integer fastFrameType) {
        this.fastFrameType = fastFrameType;
    }

    public Integer getFastMoney() {
        return fastMoney;
    }

    public void setFastMoney(Integer fastMoney) {
        this.fastMoney = fastMoney;
    }

    /**
     * 验证是否还在首时段内
     *
     * @param detail
     * @param inTime
     * @param endTime
     * @return
     */
    public boolean validateFirstTime(BaseChargeDetailPOJO detail, Date inTime, Date endTime) {

        Date temp = inTime;
        if (detail.getFastFrameType()== null) {
            detail.setFastFrameType(0);
        }
        int dateNum = Math.toIntExact(DateUtils.subDate(inTime, endTime, detail.getFastFrameType() + 2));
        return dateNum <= detail.getFastTime();
    }
}
